codeforces Round #269(div2) B解题报告

B. MUH and Important Things
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

It's time polar bears Menshykov and Uslada from the zoo of St. Petersburg and elephant Horace from the zoo of Kiev got down to business. In total, there are n tasks for the day and each animal should do each of these tasks. For each task, they have evaluated its difficulty. Also animals decided to do the tasks in order of their difficulty. Unfortunately, some tasks can have the same difficulty, so the order in which one can perform the tasks may vary.

Menshykov, Uslada and Horace ask you to deal with this nuisance and come up with individual plans for each of them. The plan is a sequence describing the order in which an animal should do all the n tasks. Besides, each of them wants to have its own unique plan. Therefore three plans must form three different sequences. You are to find the required plans, or otherwise deliver the sad news to them by stating that it is impossible to come up with three distinct plans for the given tasks.

Input

The first line contains integer n (1 ≤ n ≤ 2000) — the number of tasks. The second line contains n integers h1, h2, ..., hn (1 ≤ hi ≤ 2000), where hi is the difficulty of the i-th task. The larger number hi is, the more difficult the i-th task is.

Output

In the first line print "YES" (without the quotes), if it is possible to come up with three distinct plans of doing the tasks. Otherwise print in the first line "NO" (without the quotes). If three desired plans do exist, print in the second line n distinct integers that represent the numbers of the tasks in the order they are done according to the first plan. In the third and fourth line print two remaining plans in the same form.

If there are multiple possible answers, you can print any of them.

Sample test(s)
input
4
1 3 3 1
output
YES
1 4 2 3
4 1 2 3
4 1 3 2
input
5
2 4 1 4 8
output
NO
Note

In the first sample the difficulty of the tasks sets one limit: tasks 1 and 4 must be done before tasks 2 and 3. That gives the total of four possible sequences of doing tasks : [1, 4, 2, 3], [4, 1, 2, 3], [1, 4, 3, 2], [4, 1, 3, 2]. You can print any three of them in the answer.

In the second sample there are only two sequences of tasks that meet the conditions — [3, 1, 2, 4, 5] and [3, 1, 4, 2, 5]. Consequently, it is impossible to make three distinct sequences of tasks.


题目大意:

给出一系列任务,每个任务难度不同。现在要求找出3个不同的难度系数单调不递减序列,并输出。


解法:

        第一想法就是计算机有多少个不同的单调不递减序列,然后按照全排列的类似的方法来输出前3个。后来发现首先数字太过庞大,然后输出也不怎么知道弄= =,这个想法就不再继续考虑了。

        之前的想法似乎可以精简一点,更贴近题意。我们只需要找出3个不同的序列,而且增序排序出来的结果就是一种序列,我们可以在排序后再找出2个不同的。然而得到不同的序列,由于只能是同等难度之间进行交换,我们可以采用在排序的基础上前后交换的方法得出,只需前后难度相同就可进行交换,为了以防出现换来换去结果得到原来的结果,我们不能在原序列(即排序后)上立即交换,而是保存交换的点,以便输出且不影响结果。

代码:

#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

vector<int> h;

int n;

void init() {
	scanf("%d", &n);

	for (int i = 1; i <= n; i++) {
		int tmp;

		scanf("%d", &tmp);
		h.push_back((tmp<<16)+i);
	}
	sort(h.begin(), h.end());
}

void print(vector<int> &a) {
	for (int i = 0; i < a.size(); i++)
		printf("%d ", a[i]&0xffff);
	printf("\n");
}

void solve() {
	vector<pair<int,int> >  swaps;

	for (int i = 1; i < n && swaps.size() < 2; i++)
		if ((h[i-1]>>16) == (h[i]>>16))
			swaps.push_back(make_pair(i-1,i));

	if (swaps.size() < 2) {
		printf("NO\n");
		return;
	}

	printf("YES\n");
	print(h);
	swap(h[swaps[0].first], h[swaps[0].second]);
	print(h);
	swap(h[swaps[1].first], h[swaps[1].second]);
	print(h);
}

int main() {
	init();
	solve();
}


1

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值